Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcfwb.F90	(revision 2620)
@@ -28,13 +28,10 @@
    PRIVATE
 
-   PUBLIC   sbc_fwb       ! routine called by step
-   PUBLIC   sbc_fwb_alloc ! routine called in nemogcm.F90
-
-   REAL(wp) ::   a_fwb_b            ! annual domain averaged freshwater budget
-   REAL(wp) ::   a_fwb              ! for 2 year before (_b) and before year.
-   REAL(wp) ::   fwfold             ! fwfold to be suppressed
-   REAL(wp) ::   area               ! global mean ocean surface (interior domain)
-
-   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:) ::   e1e2    ! area of the interior domain (e1t*e2t)
+   PUBLIC   sbc_fwb    ! routine called by step
+
+   REAL(wp) ::   a_fwb_b   ! annual domain averaged freshwater budget
+   REAL(wp) ::   a_fwb     ! for 2 year before (_b) and before year.
+   REAL(wp) ::   fwfold    ! fwfold to be suppressed
+   REAL(wp) ::   area      ! global mean ocean surface (interior domain)
 
    !! * Substitutions
@@ -47,21 +44,4 @@
    !!----------------------------------------------------------------------
 CONTAINS
-
-   FUNCTION sbc_fwb_alloc()
-      !!---------------------------------------------------------------------
-      !!                ***  ROUTINE sbc_fwb_alloc  ***
-      !!---------------------------------------------------------------------
-      IMPLICIT none
-      INTEGER :: sbc_fwb_alloc
-      !!---------------------------------------------------------------------
-
-     ALLOCATE(e1e2(jpi,jpj), Stat=sbc_fwb_alloc)
-
-     IF(sbc_fwb_alloc /= 0)THEN
-        CALL ctl_warn('sbc_fwb_alloc: failed to allocate array.')
-     END IF
-
-   END FUNCTION sbc_fwb_alloc
-
 
    SUBROUTINE sbc_fwb( kt, kn_fwb, kn_fsbc )
@@ -93,7 +73,6 @@
       !!----------------------------------------------------------------------
       !
-      IF( .NOT. wrk_use(2, 1,2,3,4,5))THEN
-         CALL ctl_stop('sbc_fwb: requested workspace arrays are unavailable.')
-         RETURN
+      IF( .NOT. wrk_use(2, 1,2,3,4,5) ) THEN
+         CALL ctl_stop('sbc_fwb: requested workspace arrays are unavailable')   ;   RETURN
       END IF
       !
@@ -110,6 +89,5 @@
          IF( kn_fwb == 3 .AND. nn_sssr /= 2 )   CALL ctl_stop( 'sbc_fwb: nn_fwb = 3 requires nn_sssr = 2, we stop ' )
          !
-         e1e2(:,:) = e1t(:,:) * e2t(:,:) 
-         area = glob_sum( e1e2(:,:) )           ! interior global domain surface
+         area = glob_sum( e1e2t(:,:) )           ! interior global domain surface
       ENDIF
       
@@ -120,5 +98,5 @@
          !
          IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN
-            z_fwf = glob_sum( e1e2(:,:) * ( emp(:,:) - rnf(:,:) ) ) / area   ! sum over the global domain
+            z_fwf = glob_sum( e1e2t(:,:) * ( emp(:,:) - rnf(:,:) ) ) / area   ! sum over the global domain
             emp (:,:) = emp (:,:) - z_fwf 
             emps(:,:) = emps(:,:) - z_fwf 
@@ -143,5 +121,5 @@
          IF( MOD( kt, ikty ) == 0 ) THEN
             a_fwb_b = a_fwb
-            a_fwb   = glob_sum( e1e2(:,:) * sshn(:,:) )   ! sum over the global domain
+            a_fwb   = glob_sum( e1e2t(:,:) * sshn(:,:) )   ! sum over the global domain
             a_fwb   = a_fwb * 1.e+3 / ( area * 86400. * 365. )     ! convert in Kg/m3/s = mm/s
 !!gm        !                                                      !!bug 365d year 
@@ -168,8 +146,8 @@
             ztmsk_neg(:,:) = tmask_i(:,:) - ztmsk_pos(:,:)
             !
-            zsurf_neg = glob_sum( e1e2(:,:)*ztmsk_neg(:,:) )   ! Area filled by <0 and >0 erp 
-            zsurf_pos = glob_sum( e1e2(:,:)*ztmsk_pos(:,:) )
+            zsurf_neg = glob_sum( e1e2t(:,:)*ztmsk_neg(:,:) )   ! Area filled by <0 and >0 erp 
+            zsurf_pos = glob_sum( e1e2t(:,:)*ztmsk_pos(:,:) )
             !                                                  ! fwf global mean 
-            z_fwf = glob_sum( e1e2(:,:) * ( emp(:,:) - rnf(:,:) ) ) / area
+            z_fwf = glob_sum( e1e2t(:,:) * ( emp(:,:) - rnf(:,:) ) ) / area
             !            
             IF( z_fwf < 0._wp ) THEN         ! spread out over >0 erp area to increase evaporation
@@ -181,9 +159,9 @@
             ENDIF
             !
-            zsum_fwf   = glob_sum( e1e2(:,:) * z_fwf )         ! fwf global mean over <0 or >0 erp area
+            zsum_fwf   = glob_sum( e1e2t(:,:) * z_fwf )         ! fwf global mean over <0 or >0 erp area
 !!gm :  zsum_fwf   = z_fwf * area   ???  it is right?  I think so....
             z_fwf_nsrf =  zsum_fwf / ( zsurf_tospread + rsmall )
             !                                                  ! weight to respect erp field 2D structure 
-            zsum_erp = glob_sum( ztmsk_tospread(:,:) * erp(:,:) * e1e2(:,:) )
+            zsum_erp = glob_sum( ztmsk_tospread(:,:) * erp(:,:) * e1e2t(:,:) )
             z_wgt(:,:) = ztmsk_tospread(:,:) * erp(:,:) / ( zsum_erp + rsmall )
             !                                                  ! final correction term to apply
@@ -200,10 +178,10 @@
                IF( z_fwf < 0._wp ) THEN
                   WRITE(numout,*)'   z_fwf < 0'
-                  WRITE(numout,*)'   SUM(erp+)     = ', SUM( ztmsk_tospread(:,:)*erp(:,:)*e1e2(:,:) )*1.e-9,' Sv'
+                  WRITE(numout,*)'   SUM(erp+)     = ', SUM( ztmsk_tospread(:,:)*erp(:,:)*e1e2t(:,:) )*1.e-9,' Sv'
                ELSE
                   WRITE(numout,*)'   z_fwf >= 0'
-                  WRITE(numout,*)'   SUM(erp-)     = ', SUM( ztmsk_tospread(:,:)*erp(:,:)*e1e2(:,:) )*1.e-9,' Sv'
+                  WRITE(numout,*)'   SUM(erp-)     = ', SUM( ztmsk_tospread(:,:)*erp(:,:)*e1e2t(:,:) )*1.e-9,' Sv'
                ENDIF
-               WRITE(numout,*)'   SUM(empG)     = ', SUM( z_fwf*e1e2(:,:) )*1.e-9,' Sv'
+               WRITE(numout,*)'   SUM(empG)     = ', SUM( z_fwf*e1e2t(:,:) )*1.e-9,' Sv'
                WRITE(numout,*)'   z_fwf         = ', z_fwf      ,' Kg/m2/s'
                WRITE(numout,*)'   z_fwf_nsrf    = ', z_fwf_nsrf ,' Kg/m2/s'
@@ -218,7 +196,5 @@
       END SELECT
       !
-      IF( .NOT. wrk_release(2, 1,2,3,4,5))THEN
-         CALL ctl_stop('sbc_fwb: failed to release workspace arrays.')
-      END IF
+      IF( .NOT. wrk_release(2, 1,2,3,4,5) )   CALL ctl_stop('sbc_fwb: failed to release workspace arrays')
       !
    END SUBROUTINE sbc_fwb
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_if.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_if.F90	(revision 2620)
@@ -32,7 +32,6 @@
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -78,10 +77,7 @@
 
          ALLOCATE( sf_ice(1), STAT=ierror )
-         IF( ierror > 0 ) THEN
-            CALL ctl_stop( 'sbc_ice_if: unable to allocate sf_ice structure' )   ;   RETURN
-         ENDIF
+         IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_ice_if: unable to allocate sf_ice structure' )
          ALLOCATE( sf_ice(1)%fnow(jpi,jpj,1) )
-         IF( sn_ice%ln_tint ) ALLOCATE( sf_ice(1)%fdta(jpi,jpj,1,2) )
-
+         IF( sn_ice%ln_tint )   ALLOCATE( sf_ice(1)%fdta(jpi,jpj,1,2) )
 
          ! fill sf_ice with sn_ice and control print
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim.F90	(revision 2620)
@@ -102,6 +102,4 @@
       IF( .NOT. wrk_use(3, 1,2) ) THEN
          CALL ctl_stop( 'sbc_ice_lim: requested workspace arrays are unavailable.' )   ;   RETURN
-      ELSEIF( jpl > jpk ) THEN
-         CALL ctl_stop( 'sbc_ice_lim: extent of 3rd dimension of workspace arrays needs to exceed jpk.' )   ;   RETURN
       ENDIF
 
@@ -254,7 +252,5 @@
 !!gm   remark, the ocean-ice stress is not saved in ice diag call above .....  find a solution!!!
       !
-      IF( .NOT. wrk_release(3, 1,2) ) THEN
-         CALL ctl_stop( 'sbc_ice_lim: failed to release workspace arrays.' )
-      END IF
+      IF( .NOT. wrk_release(3, 1,2) )   CALL ctl_stop( 'sbc_ice_lim: failed to release workspace arrays.' )
       !
    END SUBROUTINE sbc_ice_lim
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 2620)
@@ -84,5 +84,5 @@
       !!---------------------------------------------------------------------
       USE wrk_nemo, ONLY: wrk_use, wrk_release
-      USE wrk_nemo, ONLY: wrk_3d_1, wrk_3d_2, wrk_3d_3
+      USE wrk_nemo, ONLY: wrk_3d_1, wrk_3d_2, wrk_3d_3   ! 3D workspace
       !!
       INTEGER, INTENT(in) ::   kt      ! ocean time step
@@ -96,12 +96,11 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(3, 1,2,3))THEN
-         CALL ctl_stop('sbc_ice_lim_2: requested workspace arrays are unavailable.')
-         RETURN
+      IF(.NOT. wrk_use(3, 1,2,3) ) THEN
+         CALL ctl_stop('sbc_ice_lim_2: requested workspace arrays are unavailable.')   ;   RETURN
       END IF
       ! Use pointers to access only sub-arrays of workspaces
       zalb_ice_os => wrk_3d_1(:,:,1:1)
       zalb_ice_cs => wrk_3d_2(:,:,1:1)
-            zsist => wrk_3d_3(:,:,1:1)
+      zsist       => wrk_3d_3(:,:,1:1)
 
       IF( kt == nit000 ) THEN
@@ -204,8 +203,8 @@
          !                                             ! Ice surface fluxes in coupled mode 
          IF( ksbc == 5 )   CALL sbc_cpl_ice_flx( reshape( frld, (/jpi,jpj,1/) ),                 &
-      &                                                   qns_tot, qns_ice, qsr_tot , qsr_ice,   &
-      &                                                   emp_tot, emp_ice, dqns_ice, sprecip,   &
-      !                                      optional arguments, used only in 'mixed oce-ice' case
-      &                                                   palbi = zalb_ice_cs, psst = sst_m, pist = sist )
+            &                                             qns_tot, qns_ice, qsr_tot , qsr_ice,   &
+            &                                             emp_tot, emp_ice, dqns_ice, sprecip,   &
+            !                                optional arguments, used only in 'mixed oce-ice' case
+            &                                             palbi = zalb_ice_cs, psst = sst_m, pist = sist )
 #endif
                            CALL lim_thd_2      ( kt )      ! Ice thermodynamics 
@@ -229,7 +228,5 @@
       IF( ln_limdyn    )   CALL lim_sbc_tau_2( kt, ub(:,:,1), vb(:,:,1) )  ! using before instantaneous surf. currents
       !
-      IF(.NOT. wrk_release(3, 1,2,3))THEN
-         CALL ctl_stop('sbc_ice_lim_2: failed to release workspace arrays.')
-      END IF
+      IF(.NOT. wrk_release(3, 1,2,3) )   CALL ctl_stop('sbc_ice_lim_2: failed to release workspace arrays')
       !
    END SUBROUTINE sbc_ice_lim_2
@@ -241,6 +238,5 @@
 CONTAINS
    SUBROUTINE sbc_ice_lim_2 ( kt, ksbc )     ! Dummy routine
-      INTEGER, INTENT(in) ::   kt      
-      INTEGER, INTENT(in) ::   ksbc    
+      INTEGER, INTENT(in) ::   kt, ksbc    
       WRITE(*,*) 'sbc_ice_lim_2: You should not have seen this print! error?', kt, ksbc
    END SUBROUTINE sbc_ice_lim_2
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 2620)
@@ -57,7 +57,7 @@
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO-consortium (2010) 
+   !! NEMO/OPA 4.0 , NEMO-consortium (2011) 
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
@@ -76,6 +76,6 @@
       INTEGER ::   icpt      ! temporary integer
       !!
-      NAMELIST/namsbc/ nn_fsbc, ln_ana  , ln_flx, ln_blk_clio, ln_blk_core, ln_cpl    ,   &
-         &             ln_apr_dyn, nn_ice , ln_dm2dc, ln_rnf, ln_ssr     , nn_fwb
+      NAMELIST/namsbc/ nn_fsbc   , ln_ana , ln_flx  , ln_blk_clio, ln_blk_core, ln_cpl,   &
+         &             ln_apr_dyn, nn_ice , ln_dm2dc, ln_rnf     , ln_ssr     , nn_fwb
       !!----------------------------------------------------------------------
 
@@ -117,4 +117,7 @@
          WRITE(numout,*) '              closed sea (=0/1) (set in namdom)          nn_closea   = ', nn_closea
       ENDIF
+
+      !                              ! allocate sbc arrays
+      IF( sbc_oce_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_init : unable to allocate sbc_oce arrays' )
 
       !                          ! Checks:
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 2620)
@@ -30,7 +30,6 @@
    PUBLIC   sbc_rnf       ! routine call in sbcmod module
    PUBLIC   sbc_rnf_div   ! routine called in sshwzv module
-   PUBLIC   sbc_rnf_alloc ! routine called in nemogcm module
-
-   !                                                      !!* namsbc_rnf namelist *
+
+   !                                                     !!* namsbc_rnf namelist *
    CHARACTER(len=100), PUBLIC ::   cn_dir       = './'    !: Root directory for location of ssr files
    LOGICAL           , PUBLIC ::   ln_rnf_depth = .false. !: depth       river runoffs attribute specified in a file
@@ -48,10 +47,10 @@
    REAL(wp)          , PUBLIC ::   rn_rfact     = 1._wp   !: multiplicative factor for runoff
 
-   INTEGER , PUBLIC                          ::   nkrnf = 0         !: nb of levels over which Kz is increased at river mouths
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   rnfmsk            !: river mouth mask (hori.)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)     ::   rnfmsk_z          !: river mouth mask (vert.)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   h_rnf             !: depth of runoff in m
-   INTEGER,  PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   nk_rnf            !: depth of runoff in model levels
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: rnf_tsc_b, rnf_tsc  !: before and now T & S contents of runoffs  [K.m/s & PSU.m/s]
+   INTEGER , PUBLIC  ::   nkrnf = 0         !: nb of levels over which Kz is increased at river mouths
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   rnfmsk              !: river mouth mask (hori.)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)     ::   rnfmsk_z            !: river mouth mask (vert.)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   h_rnf               !: depth of runoff in m
+   INTEGER,  PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   nk_rnf              !: depth of runoff in model levels
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   rnf_tsc_b, rnf_tsc  !: before and now T & S runoff contents   [K.m/s & PSU.m/s]
    
    REAL(wp) ::   r1_rau0   ! = 1 / rau0 
@@ -70,21 +69,14 @@
 CONTAINS
 
-   FUNCTION sbc_rnf_alloc()
+   INTEGER FUNCTION sbc_rnf_alloc()
       !!----------------------------------------------------------------------
       !!                ***  ROUTINE sbc_rnf_alloc  ***
       !!----------------------------------------------------------------------
-      IMPLICIT none
-      INTEGER :: sbc_rnf_alloc
-      !!----------------------------------------------------------------------
-
-      ALLOCATE(rnfmsk(jpi,jpj),         rnfmsk_z(jpk),         &
-               h_rnf(jpi,jpj),          nk_rnf(jpi,jpj),       &
-               rnf_tsc_b(jpi,jpj,jpts), rnf_tsc(jpi,jpj,jpts), &
-               Stat=sbc_rnf_alloc)
-
-      IF(sbc_rnf_alloc > 0)THEN
-         CALL ctl_warn('sbc_rnf_alloc: allocation of arrays failed.')
-      END IF
-
+      ALLOCATE( rnfmsk(jpi,jpj)         , rnfmsk_z(jpk)          ,     &
+         &      h_rnf (jpi,jpj)         , nk_rnf  (jpi,jpj)      ,     &
+         &      rnf_tsc_b(jpi,jpj,jpts) , rnf_tsc (jpi,jpj,jpts) , STAT=sbc_rnf_alloc)
+         !
+      IF( lk_mpp            )   CALL mpp_sum ( sbc_rnf_alloc )
+      IF( sbc_rnf_alloc > 0 )   CALL ctl_warn('sbc_rnf_alloc: allocation of arrays failed.')
    END FUNCTION sbc_rnf_alloc
 
@@ -296,4 +288,6 @@
       !                                   !   Type of runoff
       !                                   ! ==================
+      !                                         !==  allocate runoff arrays
+      IF( sbc_rnf_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_rnf_alloc : unable to allocate arrays' )
       !
       IF( ln_rnf_emp ) THEN                     !==  runoffs directly provided in the precipitations  ==!
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 2620)
@@ -4,5 +4,5 @@
    !! Surface module :  provide time-mean ocean surface variables
    !!======================================================================
-   !! History :  9.0   !  06-07  (G. Madec)  Original code
+   !! History :  9.0  ! 2006-07  (G. Madec)  Original code
    !!            3.3  ! 2010-10  (C. Bricaud, G. Madec)  add the Patm forcing for sea-ice
    !!----------------------------------------------------------------------
@@ -32,7 +32,6 @@
    !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssr.F90	(revision 2620)
@@ -25,9 +25,8 @@
    PRIVATE
 
-   PUBLIC   sbc_ssr       ! routine called in sbcmod
-   PUBLIC   sbc_ssr_alloc ! routine called in nemgcm
-
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   erp      !: evaporation damping   [kg/m2/s]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   qrp      !: heat flux damping        [w/m2]
+   PUBLIC   sbc_ssr    ! routine called in sbcmod
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   erp   !: evaporation damping   [kg/m2/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   qrp   !: heat flux damping        [w/m2]
 
    !                                           !!* Namelist namsbc_ssr *
@@ -46,26 +45,9 @@
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2011)
    !! $Id$
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
-
-   FUNCTION sbc_ssr_alloc()
-      !!---------------------------------------------------------------------
-      !!                  ***  ROUTINE sbc_ssr_alloc  ***
-      !!---------------------------------------------------------------------
-      IMPLICIT none
-      INTEGER :: sbc_ssr_alloc
-      !!---------------------------------------------------------------------
-
-      ALLOCATE(erp(jpi,jpj), qrp(jpi,jpj), Stat=sbc_ssr_alloc)
-
-      IF(sbc_ssr_alloc > 0)THEN
-         CALL ctl_warn('sbc_ssr_alloc: allocation of arrays failed.')
-      END IF
-
-   END FUNCTION sbc_ssr_alloc
 
    SUBROUTINE sbc_ssr( kt )
@@ -125,28 +107,34 @@
          ENDIF
 
-         IF( nn_sstr == 1 ) THEN      !* set sf_sst structure
+         IF( nn_sstr == 1 ) THEN      !* set sf_sst structure & allocate arrays
             !
             ALLOCATE( sf_sst(1), STAT=ierror )
-            IF( ierror > 0 ) THEN
-               CALL ctl_stop( 'sbc_ssr: unable to allocate sf_sst structure' )   ;   RETURN
-            ENDIF
-            ALLOCATE( sf_sst(1)%fnow(jpi,jpj,1) )
+            IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_ssr: unable to allocate sf_sst structure' )
+            ALLOCATE( sf_sst(1)%fnow(jpi,jpj,1), STAT=ierror )
+            IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_ssr: unable to allocate sf_sst now array' )
             !
             ! fill sf_sst with sn_sst and control print
             CALL fld_fill( sf_sst, (/ sn_sst /), cn_dir, 'sbc_ssr', 'SST restoring term toward SST data', 'namsbc_ssr' )
-            IF( sf_sst(1)%ln_tint ) ALLOCATE( sf_sst(1)%fdta(jpi,jpj,1,2) )
-         ENDIF
-         !
-         IF( nn_sssr >= 1 ) THEN      ! set sf_sss structure
+            IF( sf_sst(1)%ln_tint )   ALLOCATE( sf_sst(1)%fdta(jpi,jpj,1,2), STAT=ierror )
+            IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_ssr: unable to allocate sf_sst data array' )
+            !
+            ALLOCATE( qrp(jpi,jpj), STAT=ierror )
+            IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_ssr: unable to allocate qrp array' )
+         ENDIF
+         !
+         IF( nn_sssr >= 1 ) THEN      ! set sf_sss structure & allocate arrays
             !
             ALLOCATE( sf_sss(1), STAT=ierror )
-            IF( ierror > 0 ) THEN
-               CALL ctl_stop( 'sbc_ssr: unable to allocate sf_sss structure' )   ;   RETURN
-            ENDIF
-            ALLOCATE( sf_sss(1)%fnow(jpi,jpj,1) )
+            IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_ssr: unable to allocate sf_sss structure' )
+            ALLOCATE( sf_sss(1)%fnow(jpi,jpj,1), STAT=ierror )
+            IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_ssr: unable to allocate sf_sss now array' )
             !
             ! fill sf_sss with sn_sss and control print
             CALL fld_fill( sf_sss, (/ sn_sss /), cn_dir, 'sbc_ssr', 'SSS restoring term toward SSS data', 'namsbc_ssr' )
-            IF( sf_sss(1)%ln_tint )ALLOCATE( sf_sss(1)%fdta(jpi,jpj,1,2) )
+            IF( sf_sss(1)%ln_tint )   ALLOCATE( sf_sss(1)%fdta(jpi,jpj,1,2), STAT=ierror )
+            IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_ssr: unable to allocate sf_sss data array' )
+            !
+            ALLOCATE( erp(jpi,jpj), STAT=ierror )
+            IF( ierror > 0 )   CALL ctl_stop( 'STOP', 'sbc_ssr: unable to allocate erp array' )
          ENDIF
          !
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 2619)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 2620)
@@ -472,5 +472,4 @@
      
      USE dynzdf_exp,   ONLY: dyn_zdf_exp_alloc
-     USE geo2ocean,    ONLY: geo2oce_alloc
 #if   defined key_mpp_mpi  
      USE lib_mpp,      ONLY: lib_mpp_alloc
@@ -480,13 +479,5 @@
      USE obc_oce,      ONLY: obc_oce_alloc
 #endif
-     USE sbcblk_clio,  ONLY: sbc_blk_clio_alloc
-#if defined key_oasis3 || defined key_oasis4
-     USE sbccpl,       ONLY: sbc_cpl_init_alloc
-#endif
-     USE sbcdcy,       ONLY: sbc_dcy_alloc
-     USE sbcfwb,       ONLY: sbc_fwb_alloc
-     USE sbc_oce,      ONLY: sbc_oce_alloc
-     USE sbcrnf,       ONLY: sbc_rnf_alloc
-     USE sbcssr,       ONLY: sbc_ssr_alloc
+
      USE sol_oce,      ONLY: sol_oce_alloc
      USE solmat,       ONLY: sol_mat_alloc
@@ -565,5 +556,4 @@
 
       ierr = ierr + dyn_zdf_exp_alloc()
-      ierr = ierr + geo2oce_alloc()
 #if defined key_mpp_mpi 
       ierr = ierr + lib_mpp_alloc()
@@ -573,13 +563,5 @@
       ierr = ierr + obc_oce_alloc()
 #endif
-      ierr = ierr + sbc_blk_clio_alloc()
-#if defined key_oasis3 || defined key_oasis4
-      ierr = ierr + sbc_cpl_init_alloc()
-#endif
-      ierr = ierr + sbc_dcy_alloc()
-      ierr = ierr + sbc_fwb_alloc()
-      ierr = ierr + sbc_oce_alloc()
-      ierr = ierr + sbc_rnf_alloc()
-      ierr = ierr + sbc_ssr_alloc()
+
       ierr = ierr + sol_oce_alloc()
       ierr = ierr + sol_mat_alloc()
@@ -763,6 +745,6 @@
       RETURN
       !
-  END SUBROUTINE factorise
-
-  !!======================================================================
+   END SUBROUTINE factorise
+
+   !!======================================================================
 END MODULE nemogcm
